//
//  ViewController.swift
//  waterFlowSwiftDemo
//
//  Created by TigerNong on 2018/7/4.
//  Copyright © 2018年 TigerNong. All rights reserved.
//

import UIKit


class ViewController: UIViewController,UICollectionViewDelegate,UICollectionViewDataSource,TNCollectionViewLayoutDelegate {

    var collectionView : UICollectionView?
   fileprivate lazy var shops : [TNShop] = []
    override func viewDidLoad() {
        super.viewDidLoad()
        
        let path = Bundle.main.path(forResource: "shop", ofType: "plist")
        let arr = NSArray(contentsOfFile: path!)
        
        for dic in arr! {
            let shop : TNShop? = TNShop()
            let dict = dic as! NSDictionary
            shop!.h = dict["h"] as? CGFloat
            shop!.w = dict["w"] as? CGFloat
            shop!.img = dict["img"] as? String
            shop!.price = dict["price"] as? String
            shops.append(shop!)
        }
        
        setUpCollectionView()
    }
    
    func setUpCollectionView(){

        let layout : TNCollectionViewLayout = TNCollectionViewLayout()
        layout.delegate = self
        self.collectionView = UICollectionView(frame: self.view.bounds, collectionViewLayout: layout)
        self.view.addSubview(self.collectionView!)
        self.collectionView?.backgroundColor = UIColor.white
        self.collectionView?.delegate = self
        self.collectionView?.dataSource = self
        

        self.collectionView?.register(UINib(nibName:"TNShopCell", bundle: nil), forCellWithReuseIdentifier: "TNShopCell")
        
    }
    
    
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return self.shops.count
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        let cell : TNShopCell = collectionView.dequeueReusableCell(withReuseIdentifier: "TNShopCell", for: indexPath) as! TNShopCell
        let shop : TNShop = self.shops[indexPath.item]
        cell.shop = shop
        return cell
    }
    
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        let secondVC = SecondViewController()
        let shop = self.shops[indexPath.item]
        secondVC.url = shop.img
        let navi : UINavigationController = UINavigationController(rootViewController: secondVC)
        present(navi, animated: true, completion: nil)
    }
    
    //Mark - 自定义layout的delegate
    func waterFlowLayout(layout: TNCollectionViewLayout, indexPath: NSIndexPath, itemWidth: CGFloat) -> CGFloat {
        let shop : TNShop = self.shops[indexPath.item]
        let heigth = itemWidth * shop.h! / shop.w!;
        return heigth
    }
    
    
    

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


}

